using System;
using System.IO;
using Altiris.NS.ItemManagement;
using Altiris.NS.Security;
using Altiris.PatchManagementCore.Policies;
using Altiris.PatchManagementCore.Resources;

class DisableBulletin
{
    static int Main(string[] args)
    {
        Guid bulletinGuid;
        if (args.Length != 1)
        {
			Console.WriteLine("Programmatically Disable Bulletin");
			Console.WriteLine("Usage: nscript.exe DisableBulletin.cs <BulletinGuid>");
            return 1;
        }
		
        if (!Guid.TryParse(args[0], out bulletinGuid))
        {
            Console.WriteLine("Error: Cannot create guid from '{0}'", args[0]);
            return 1;
        }

        SecurityContextManager.SetContextData();

        var bulletin = Item.GetItem(bulletinGuid, ItemLoadFlags.Writeable) as SoftwareBulletinResource;

        if (bulletin == null)
        {
            Console.WriteLine("Error: Bulletin '{0}' not found.", bulletinGuid);
            return 1;
        }
		
		var oldValue = bulletin.RaiseMessage;
		try {
			bulletin.RaiseMessage = false;
			bulletin.IsDisabledByUser = true;
			bulletin.Enabled = false;
			bulletin.setAdvertStagedState(false);
			bulletin.deleteAllPendingUpdates();
			bulletin.Save();
		} 
		catch (Exception ex)
		{
			Console.WriteLine("Error: Bulletin '{0}' could not be disabled. Exception: {1}", bulletin.Name, ex);
			return 1;
		}
		finally 
		{
			bulletin.RaiseMessage = oldValue;
		}
		
		Console.WriteLine("Bulletin '{0}' Disabled.", bulletin.Name);
        return 0;
    }
}